> ## Documentation Index > Fetch the complete documentation index at: https://docs.validatar.com/llms.txt > Use this file to discover all available pages before exploring further. # Update Data Source Custom Fields > Updates the list of data source custom fields ## OpenAPI ````json PUT /api/v1/Catalog/custom-fields/data-source { "openapi": "3.0.4", "info": { "title": "Validatar API Documentation", "description": "# Overview\nThe Validatar Core website provides [REST](https://en.wikipedia.org/wiki/Representational_state_transfer) API access to the back-end functionality included in Validatar. This documentation provides the ability to call the API endpoints directly, provided a user is authorized to do so. If you do not currently have the Validatar app, visit the [Validatar home page](https://www.validatar.com/) to see details. If you are looking for the application documentation, visit the [Validatar application documentation page](https://docs.validatar.com/docs).\n\n\n\n# Scopes\n| Scope | Description |\n|----------------|-------------|\n| Authoring | The endpoints in Authoring provide configuration and creation operations. This includes operations such as creating folders or updating tests. |\n| Data Steward | The endpoints in Data Steward allow technical, custom, and lineage metadata ingestion at the data source, schema, table, and column levels. |\n| Execution | The endpoints in Execution allow executing standard/template tests or jobs. |\n| Catalog | The endpoints in Catalog allow retrieving technical, custom, and lineage metadata information at the data source, schema, table, and column levels. |\n| Reporting | The endpoints in Reporting allow retrieving a list of reports and executing reports. |\n| Security Admin | The endpoints in Security Admin allow configuring user groups and managing user permissions. |\n\n", "version": "v1" }, "servers": [ { "url": "https://training.cloud.validatar.com/core" } ], "tags": [ { "name": "Authoring" }, { "name": "Catalog" }, { "name": "Data Steward" }, { "name": "Execution" }, { "name": "Reporting" }, { "name": "Security Admin" } ], "paths": { "/api/v1/Catalog/custom-fields/data-source": { "put": { "tags": [ "Catalog" ], "summary": "Update Data Source Custom Fields", "description": "Updates the list of data source custom fields", "requestBody": { "content": { "application/json-patch+json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldListing" } }, "application/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldListing" } }, "text/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldListing" } }, "application/*+json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldListing" } } } }, "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.Common.SuccessResponse" } } } }, "400": { "description": "Bad Request", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.Common.ErrorListResponse" } } } }, "403": { "description": "Forbidden" } }, "security": [ {} ] } } }, "components": { "schemas": { "Configuration.Api.Models.v1.CustomFieldListing": { "title": "CustomFieldListing:DataSource", "type": "object", "properties": { "sections": { "type": "array", "items": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldSection" }, "description": "List of custom field sections" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.Common.SuccessResponse": { "title": "SuccessResponse", "type": "object", "properties": { "message": { "type": "string", "nullable": true } }, "additionalProperties": false }, "Configuration.Api.Models.v1.Common.ErrorListResponse": { "title": "ErrorListResponse", "type": "object", "properties": { "errors": { "type": "array", "items": { "type": "string" } } }, "additionalProperties": false }, "Configuration.Api.Models.v1.CustomFieldSection": { "title": "CustomFieldSection:DataSource", "type": "object", "properties": { "name": { "type": "string", "description": "The name of the section", "nullable": true }, "fields": { "type": "array", "items": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldDetail" }, "description": "List of fields in the section" }, "visibility": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.SectionFieldVisibility" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.CustomFieldDetail": { "title": "CustomFieldDetail:DataSource", "type": "object", "properties": { "name": { "type": "string", "description": "The name of the field", "nullable": true }, "description": { "type": "string", "description": "The description of the field", "nullable": true }, "referenceKey": { "type": "string", "description": "The reference key of the field", "nullable": true }, "dataType": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldDataType" }, "options": { "type": "array", "items": { "type": "string" }, "description": "List of options for the field" }, "visibility": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.SectionFieldVisibility" }, "referenceOptions": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.ReferenceFieldOptions" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.SectionFieldVisibility": { "title": "SectionFieldVisibility:DataSource", "type": "object", "properties": { "type": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.CustomFieldVisibility" }, "technicalMetadataRules": { "type": "array", "items": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.MetaObjectTechnicalDataSourceFilter" }, "description": "List of technical metadata visibility rules" }, "customMetadataRules": { "type": "array", "items": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.MetaObjectCustomDataSourceFilter" }, "description": "List of custom metadata visibility rules" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.CustomFieldDataType": { "title": "CustomFieldDataType", "enum": [ "ShortText", "Date", "Paragraph", "UserGroupList", "Dropdown", "TagList", "TableMetadataReference", "ColumnMetadataReference" ], "type": "string" }, "Configuration.Api.Models.v1.ReferenceFieldOptions": { "title": "ReferenceFieldOptions", "type": "object", "properties": { "scope": { "$ref": "#/components/schemas/Configuration.Api.Models.v1.MetadataReferenceScope" }, "allowMultipleValues": { "type": "boolean", "description": "Whether to allow multiple values for the field" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.CustomFieldVisibility": { "title": "CustomFieldVisibility", "enum": [ "AlwaysShow", "AlwaysHide", "RuleLogic" ], "type": "string" }, "Configuration.Api.Models.v1.MetaObjectTechnicalDataSourceFilter": { "title": "MetaObjectTechnicalDataSourceFilter", "type": "object", "properties": { "field": { "$ref": "#/components/schemas/Common.DataSourceMetaDataFilterField" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.MetaObjectCustomDataSourceFilter": { "title": "MetaObjectCustomDataSourceFilter", "type": "object", "properties": { "objectType": { "$ref": "#/components/schemas/Common.DataSourceCustomFieldObjectType" } }, "additionalProperties": false }, "Configuration.Api.Models.v1.MetadataReferenceScope": { "title": "MetadataReferenceScope", "enum": [ "AnyDataSource", "SameDataSource", "SameSchema", "SameTable" ], "type": "string" }, "Common.DataSourceMetaDataFilterField": { "title": "DataSourceMetaDataFilterField", "enum": [ "DataSourceName", "DataSourceEnvironment", "DataSourceConnectionType", "DataSourceServer", "DataSourceDatabaseName", "DataSourceTemplate" ], "type": "string" }, "Common.DataSourceCustomFieldObjectType": { "title": "DataSourceCustomFieldObjectType", "enum": [ "DataSource" ], "type": "string" } } } } ````